> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/reference/sql-commands/sql-droproutine.md).

# DROP ROUTINE

### DROP ROUTINE

DROP ROUTINE — remove a routine

### Synopsis

```

DROP ROUTINE [ IF EXISTS ] name [ ( [ [ argmode ] [ argname ] argtype [, ...] ] ) ] [, ...]
    [ CASCADE | RESTRICT ]
```

### Description

`DROP ROUTINE` removes the definition of one or more existing routines. The term “routine” includes aggregate functions, normal functions, and procedures. See under [DROP AGGREGATE](/reference/sql-commands/sql-dropaggregate.md), [DROP FUNCTION](/reference/sql-commands/sql-dropfunction.md), and [DROP PROCEDURE](/reference/sql-commands/sql-dropprocedure.md) for the description of the parameters, more examples, and further details.

### Notes

The lookup rules used by `DROP ROUTINE` are fundamentally the same as for `DROP PROCEDURE`; in particular, `DROP ROUTINE` shares that command's behavior of considering an argument list that has no *`argmode`* markers to be possibly using the SQL standard's definition that `OUT` arguments are included in the list. (`DROP AGGREGATE` and `DROP FUNCTION` do not do that.)

In some cases where the same name is shared by routines of different kinds, it is possible for `DROP ROUTINE` to fail with an ambiguity error when a more specific command (`DROP FUNCTION`, etc.) would work. Specifying the argument type list more carefully will also resolve such problems.

These lookup rules are also used by other commands that act on existing routines, such as `ALTER ROUTINE` and `COMMENT ON ROUTINE`.

### Examples

To drop the routine `foo` for type `integer`:

```

DROP ROUTINE foo(integer);
```

This command will work independent of whether `foo` is an aggregate, function, or procedure.

### Compatibility

This command conforms to the SQL standard, with these PostgreSQL extensions:

* The standard only allows one routine to be dropped per command.
* The `IF EXISTS` option is an extension.
* The ability to specify argument modes and names is an extension, and the lookup rules differ when modes are given.
* User-definable aggregate functions are an extension.

### See Also

[DROP AGGREGATE](/reference/sql-commands/sql-dropaggregate.md), [DROP FUNCTION](/reference/sql-commands/sql-dropfunction.md), [DROP PROCEDURE](/reference/sql-commands/sql-dropprocedure.md), [ALTER ROUTINE](/reference/sql-commands/sql-alterroutine.md)

Note that there is no `CREATE ROUTINE` command.

***

原文：[PostgreSQL 18.6 Documentation](https://www.postgresql.org/docs/18/sql-droproutine.html)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.postgresql.tw/reference/sql-commands/sql-droproutine.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
